#include <iostream>
#include <map>
using namespace std;
bool *alive;
map<int, char> *roads;
char *strengths;
int cityCount,aliveCount,roadCount,alienCount;
char alienStrength;

void invade(int city, int strength){
	if (alive[city]){
		alive[city]=false;
		aliveCount--;
	}
	strengths[city]=strength;
	map<int, char>::iterator iter;   
  	for( iter = roads[city].begin(); iter != roads[city].end(); iter++ ){
		if (iter->second < strength && strengths[iter->first]<strength)
			invade(iter->first,strength-iter->second);
	}
}

int main(int argc, char** argv)
{
	int c1,c2,d;
	scanf("%d %d %d %d",&cityCount,&roadCount,&alienCount,&alienStrength);
	while (cityCount){
		aliveCount=cityCount;
		alive = new bool[cityCount];
		strengths= new char[cityCount];
		roads = new map<int, char>[cityCount];
		for (int i=0;i<cityCount;i++){
			alive[i]=true; strengths[i]=0;
		}
		for (int i=0;i<roadCount;i++){
			scanf("%d %d %d",&c1,&c2,&d);
			roads[c1-1][c2-1]=roads[c2-1][c1-1]=d;
		}
		for (int i=0;i<alienCount;i++){
			scanf("%d",&c1);
			invade(c1-1,alienStrength);
			printf("%d\n",aliveCount);
		}
		printf("\n");
		delete [] roads;
		delete [] alive;
		delete [] strengths;
		scanf("%d %d %d %d",&cityCount,&roadCount,&alienCount,&alienStrength);
	}
	return 0;
}
